.386

.model flat, stdcall

option casemap:none

include \masm32\include\windows.inc
include \masm32\include\gdi32.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib

WinMain proto :DWORD, :DWORD, :DWORD, :DWORD

.data
ClassName db "Parent", 0
ChildClassName db "Child", 0
AppName db "Project", 0

.data?
hInstance dd ?
CommandLine dd ?
ChildHandlesArray HWND 13 dup(?)

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance, eax

	invoke GetCommandLine
	mov    CommandLine, eax

	invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess, eax

WinMain PROC hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	
	mov wc.cbSize, SIZEOF WNDCLASSEX
	mov wc.style, CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc, OFFSET WndProc
	mov wc.cbClsExtra, NULL
	mov wc.cbWndExtra, NULL
	push hInst
	pop wc.hInstance
	mov wc.hbrBackground, COLOR_WINDOW+1
	mov wc.lpszMenuName, NULL
	mov wc.lpszClassName, OFFSET ClassName
	invoke LoadIcon, NULL, IDI_APPLICATION
	mov wc.hIcon, eax
	mov wc.hIconSm, eax
	invoke LoadCursor, NULL, IDC_ARROW
	mov wc.hCursor, eax

	invoke RegisterClassEx, ADDR wc
	
	mov wc.lpfnWndProc, OFFSET ChildWndProc
	mov wc.cbWndExtra, 4
	mov wc.lpszClassName, OFFSET ChildClassName
	mov wc.hIcon, NULL
	mov wc.hIconSm, NULL

	invoke RegisterClassEx, ADDR wc

	invoke CreateWindowEx, NULL, ADDR ClassName, ADDR AppName,\
			WS_OVERLAPPEDWINDOW,\
			CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,\
			NULL, NULL, hInst, NULL
	mov hwnd, eax

	invoke ShowWindow, hwnd, SW_SHOWNORMAL
	invoke UpdateWindow, hwnd

	.WHILE TRUE
		invoke GetMessage, ADDR msg, NULL, 0, 0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW

	mov eax, msg.wParam
	ret
WinMain endp

WndProc PROC hwnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL cxClient:DWORD
	LOCAL cyClient:DWORD
	LOCAL rect:RECT
	LOCAL tempx:DWORD
	LOCAL tempy:DWORD
	LOCAL i:DWORD
	LOCAL temp:DWORD	; y
	LOCAL temp1:DWORD	; x
	LOCAL temp2:DWORD	; width
	LOCAL temp3:DWORD	; height
	LOCAL temp4:DWORD	; a temp
	LOCAL temp5:DWORD	; another temp

	.if uMsg==WM_CREATE
; filling the ChildHandlesArray(13013, ..., 13001)	
		mov ecx, 13
		push esi
		xor esi, esi
	label1::
		mov edx, 13000
		add edx, ecx
		push ecx
		invoke CreateWindowEx, NULL, ADDR ChildClassName, NULL,\
			WS_CHILDWINDOW or WS_VISIBLE,\
			0, 0, 0, 0,\
			hwnd, edx, hInstance, NULL
		mov [ChildHandlesArray+esi], eax
		add esi, 4
		pop ecx
		loop label1
		pop esi

	.elseif uMsg==WM_SIZE
		mov eax, lParam
		mov edx, eax
		and eax, 0FFFFh
		shr edx, 16
		mov cxClient, eax; Client width
		mov cyClient, edx; Client height
		
		.if cxClient == 0
			mov cxClient, 10
		.endif
		
		.if cyClient == 0
			mov cyClient, 10
		.endif

		finit
	
; child windows 1..4
		mov temp2, 4
		fld1				; 1
		fild temp2			; 4, 1
		fdivp ST(1), ST(0)	; 1/4
		fild cxClient		; cxClient, (1/4)
		fmulp ST(1), ST(0)	; cxClient * (1/4)
		fistp temp2			; temp2 = ST(0), FPU stack balanced

		mov temp3, 7
		fld1				; 1
		fild temp3			; 7, 1
		fdivp ST(1), ST(0)	; 1/7
		fild cyClient		; cxClient, (1/7)
		fmulp ST(1), ST(0)	; cxClient * (1/7)
		fistp temp3			; temp3 = ST(0), FPU stack balanced

		mov ecx, 4
		push esi
		xor esi, esi
		push edi
		xor edi, edi
	label2::
		mov i, edi

		mov temp1, 4
		fild i				; i
		fild temp1			; 4, i
		fdivp ST(1), ST(0)	; i/4
		fild cxClient		; cxClient, (i/4)
		fmulp ST(1), ST(0)	; cxClient * (i/4)
		fistp temp1			; temp1 = ST(0), FPU stack balanced

		push ecx
		invoke MoveWindow, [ChildHandlesArray+esi], temp1, 0, temp2, temp3, TRUE
		inc edi
		add esi, 4
		pop ecx
		loop label2

		mov eax, temp2
		mov temp4, eax		; cxClient * (1/4)

; child windows 7..12
		mov temp, 6
		fild temp			; 6
		mov temp, 7
		fild temp			; 7, 6
		fdivp ST(1), ST(0)	; 6/7
		fild cyClient		; cyClient, (6/7)
		fmulp ST(1), ST(0)	; cyClient * (6/7)
		fistp temp			; temp = ST(0), FPU stack balanced

		mov eax, temp
		mov temp5, eax		; cyClient * (6/7)

		mov temp2, 8
		fld1				; 1
		fild temp2			; 8, 1
		fdivp ST(1), ST(0)	; 1/8
		fild cxClient		; cxClient, (1/8)
		fmulp ST(1), ST(0)	; cxClient * (1/8)
		fistp temp2			; temp2 = ST(0), FPU stack balanced

		mov ecx, 6
		xor esi, esi
		add esi ,24
		xor edi, edi
	label3::
		mov i, edi

		mov temp1, 8
		fild i				; i
		fild temp1			; 8, i
		fdivp ST(1), ST(0)	; i/8
		fild cxClient		; cxClient, (i/8)
		fmulp ST(1), ST(0)	; cxClient * (i/8)
		fistp temp1			; temp1 = ST(0), FPU stack balanced

		push ecx
		invoke MoveWindow, [ChildHandlesArray+esi], temp1, temp, temp2, temp3, TRUE
		inc edi
		add esi, 4
		pop ecx
		loop label3
		pop edi
		pop esi

		mov eax, temp3
		mov temp, eax		; cxClient * (1/7)

; child window 5
		mov temp2, 3
		fild temp2			; 3
		mov temp2, 4
		fild temp2			; 4, 3
		fdivp ST(1), ST(0)	; 3/4
		fild cxClient		; cxClient, (3/4)
		fmulp ST(1), ST(0)	; cxClient * (3/4)
		fistp temp2			; temp = ST(0), FPU stack balanced

		mov temp3, 5
		fild temp3			; 5
		mov temp3, 7
		fild temp3			; 7, 5
		fdivp ST(1), ST(0)	; 5/7
		fild cyClient		; cyClient, (5/7)
		fmulp ST(1), ST(0)	; cyClient * (5/7)
		fistp temp3			; temp = ST(0), FPU stack balanced
		invoke MoveWindow, [ChildHandlesArray+16], 0, temp, temp2, temp3, TRUE

; child window 6
		invoke MoveWindow, [ChildHandlesArray+20], temp2, temp, temp4, temp3, TRUE
		
; child window 13
		invoke MoveWindow, [ChildHandlesArray+48], temp2, temp5, temp4, temp, TRUE

    .elseif uMsg==WM_DESTROY
		invoke PostQuitMessage, NULL

	.else
		invoke DefWindowProc, hwnd, uMsg, wParam, lParam
		ret

	.endif
	xor eax,eax
	ret
WndProc endp

ChildWndProc PROC hwnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL hdc:HDC
	LOCAL ps:PAINTSTRUCT
	LOCAL rect:RECT
	LOCAL temp, temp1, temp2:DWORD

	.if uMsg==WM_CREATE
		invoke SetWindowLong,hwnd, 0, 0

	.elseif uMsg==WM_LBUTTONDOWN
		invoke GetWindowLong, hwnd, 0
		xor eax, 1
		invoke SetWindowLong, hwnd, 0, eax
		invoke InvalidateRect, hwnd, NULL, FALSE

	.elseif uMsg==WM_PAINT
		invoke BeginPaint, hwnd, ADDR ps
		mov hdc, eax
		invoke GetClientRect, hwnd, ADDR rect
		invoke Rectangle, hdc, 0, 0, rect.right, rect.bottom

		invoke GetWindowLong, hwnd, 0
		.if eax
			invoke MoveToEx, hdc, 0, 0, NULL
			invoke LineTo, hdc, rect.right, rect.bottom
			invoke MoveToEx, hdc, 0, rect.bottom, NULL
			invoke LineTo, hdc, rect.right, 0
		.endif
		
		invoke EndPaint, hwnd, ADDR ps
	
	.else
		invoke DefWindowProc, hwnd, uMsg, wParam, lParam
		ret

	.endif
	xor eax, eax
	ret

ChildWndProc endp
end start